## ros-indigo-minas-control 1.0.9

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(minas_control)

find_package(catkin REQUIRED COMPONENTS controller_manager diagnostic_updater transmission_interface hardware_interface sensor_msgs joint_limits_interface trajectory_msgs ethercat_manager soem)

###################################
## catkin specific configuration ##
###################################
catkin_package(
  CATKIN_DEPENDS diagnostic_updater trajectory_msgs sensor_msgs)

###########
## Build ##
###########

include_directories(
  include
  ${catkin_INCLUDE_DIRS}
  ## The following work around allows SOEM headers to include other SOEM headers.
  ## SOEM headers assume all headers are installed in a flat directory structure
  ## See https://github.com/smits/soem/issues/4 for more information.
  ${soem_INCLUDE_DIRS}/soem
)

## Declare a C++ library
add_library(minas_client src/minas_client.cpp)

## Declare a C++ executable for ROS_CONTROL
add_executable(main src/main.cpp src/minas_hardware_interface.cpp)

## Declare a C++ executable
add_executable(slaveinfo src/slaveinfo.cpp)
add_executable(simple_test src/simple_test.cpp)
add_executable(reset src/reset.cpp)

## Specify libraries to link a library or executable target against
target_link_libraries(main ${catkin_LIBRARIES} minas_client)
target_link_libraries(slaveinfo ${catkin_LIBRARIES})
target_link_libraries(simple_test ${catkin_LIBRARIES} minas_client)
target_link_libraries(reset ${catkin_LIBRARIES} minas_client)

function(set_sudo_binary tgt)
  get_target_property(loc ${tgt} "LOCATION")
  string(ASCII 27 ESCAPE)
  add_custom_target(sudo_${tgt}
    COMMAND sudo -n sh -c 'setcap cap_net_raw,cap_ipc_lock=+ep ${loc}' || (>&2 echo "${ESCAPE}[31m#\ type\ following\ command\ before\ execute\ reset...\ sudo\ setcap cap_net_raw,cap_ipc_lock=+ep\ ${loc}${ESCAPE}[0m")
    DEPENDS bin/${tgt})
  add_custom_target(sudo_${tgt}_all ALL DEPENDS sudo_${tgt})
endfunction()
set_sudo_binary(main)
set_sudo_binary(slaveinfo)
set_sudo_binary(simple_test)
set_sudo_binary(reset)

#############
## Install ##
#############

## Mark executables and/or libraries for installation
install(TARGETS slaveinfo simple_test reset minas_client main
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)
# https://github.com/tork-a/minas/issues/20 / http://stackoverflow.com/questions/3352041/creating-binary-with-cmake-removes-runtime-path
set_property(TARGET slaveinfo PROPERTY INSTALL_RPATH_USE_LINK_PATH TRUE)
set_property(TARGET simple_test PROPERTY INSTALL_RPATH_USE_LINK_PATH TRUE)
set_property(TARGET reset PROPERTY INSTALL_RPATH_USE_LINK_PATH TRUE)
set_property(TARGET minas_client PROPERTY INSTALL_RPATH_USE_LINK_PATH TRUE)
set_property(TARGET main PROPERTY INSTALL_RPATH_USE_LINK_PATH TRUE)

install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION})

install(DIRECTORY launch
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION})

#############
## Testing ##
#############

if(CATKIN_ENABLE_TESTING)
  find_package(catkin REQUIRED COMPONENTS rostest roslaunch)
  file(GLOB LAUNCH_FILES launch/*.launch)
  foreach(LAUNCH_FILE ${LAUNCH_FILES})
    message(status "Testing ${LAUNCH_FILE}")
    roslaunch_add_file_check(${LAUNCH_FILE})
  endforeach()
endif()

#############
## Release ##
#############

# debbuild
# catkin build minas_control --make-args debbuild
# ROS_PARALLEL_JOBS='' catkin_make --pkg minas_control -- debbuild
add_custom_target(debbuild_${PROJECT_NAME}
  COMMAND sudo -n true || (>&2 echo "debbuild need sudo access to make debs" && exit 1)
  COMMAND bloom-generate rosdebian --os-name ubuntu --os-version trusty --ros-distro indigo
  COMMAND MAKEFLAGS= fakeroot debian/rules binary
  COMMAND find debian obj-x86_64-linux-gnu -type f -not -name postinst -print0 | xargs -0 rm --
  COMMAND find debian obj-x86_64-linux-gnu -type d -empty -delete
  WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
  )

# make docs
# ROS_PARALLEL_JOBS='' catkin_make --pkg minas_control -- docbuild
add_custom_target(docbuild_${PROJECT_NAME}
  COMMAND cmake -E remove_directory output
  COMMAND cmake -E make_directory output
  COMMAND sphinx-build -b latex doc output
  COMMAND sed -i 's@\\\\chapter{[0-9. ]*@\\\\chapter{@' output/minas_control.tex
  COMMAND sed -i 's@\\\\section{[0-9. ]*@\\\\section{@' output/minas_control.tex
  COMMAND sed -i 's@\\\\subsection@\\\\subsubsection@' output/minas_control.tex
  COMMAND sed -i 's@\\\\section@\\\\subsection@' output/minas_control.tex
  COMMAND sed -i 's@\\\\chapter@\\\\section@' output/minas_control.tex
  # COMMAND sed -i 's@\\\\tableofcontents@\\\\chapter{unicub\\\\_gazebo} %\\\\tableofcontents@' output/minas_control.tex
  COMMAND sed -i 's@\\\\tableofcontents@\\\\setcounter{chapter}{1}\\\\setcounter{tocdepth}{3}\\\\tableofcontents@' output/minas_control.tex
  COMMAND sed -i 's@\\\\setbox0@\\\\iffalse@' output/minas_control.tex
  COMMAND sed -i 's@{\\\\box0}\\\\end{center}@{\\\\box0}\\\\end{center}\\\\fi@' output/minas_control.tex
  COMMAND sed -i 's@\\\\def\\\\PYGZsq{\\S*}@\\\\usepackage{upquote}\\\\def\\\\PYGZsq{\\\\textquotesingle}@' output/minas_control.tex
  COMMAND make -C output
  COMMAND cmake -E copy output/${PROJECT_NAME}.pdf output/${PROJECT_NAME}-${minas_control_VERSION}.pdf
  WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
  )

=== debian/changelog ===
ros-indigo-minas-control (1.0.9-0trusty) trusty; urgency=high

  * enable to publish actual position/velocity/torque value as /diagnostics (#67 <https://github.com/tork-a/minas/issues/67>)
  * fix simple test without arguments (#68 <https://github.com/tork-a/minas/issues/68>)
  * onsite fix for encoder offset(#66 <https://github.com/tork-a/minas/issues/66>)
  * set default ifname to eth0
  * add try/catch in main function of test_simple.cpp, show help() when it failes to run EtherCatManager
  * display input.position_actual_value in EtherCATJointControlInterface::EtherCATJointControlInterface
  * fix wrong variable print
  * Contributors: Ryosuke Tajima, Tokyo Opensource Robotics Developer 534

 -- Tokyo Opensource Robotics Kyokai (TORK) Developer Team <dev@opensource-robotics.tokyo.jp>  Thu, 01 Mar 2018 15:00:00 -0000

ros-indigo-minas-control (1.0.8-0trusty) trusty; urgency=high

  * Add parameter home_encoder_offset (#63 <https://github.com/tork-a/minas/issues/63>)
  * Reduce sleep time in each client (#51 <https://github.com/tork-a/minas/issues/51>)
  * Add dependency on tinyxml (#62 <https://github.com/tork-a/minas/issues/62>)
  * Contributors: Ryosuke Tajima

 -- Tokyo Opensource Robotics Kyokai (TORK) Developer Team <dev@opensource-robotics.tokyo.jp>  Mon, 27 Nov 2017 15:00:00 -0000

ros-indigo-minas-control (1.0.6-0trusty) trusty; urgency=high



 -- Tokyo Opensource Robotics Kyokai (TORK) Developer Team <dev@opensource-robotics.tokyo.jp>  Mon, 11 Sep 2017 15:00:00 -0000

ros-indigo-minas-control (1.0.5-0trusty) trusty; urgency=high

  * add .travis.yml using ros_build_farm (#58 <https://github.com/tork-a/minas/issues/58>)
    * add rosdoc.yaml
    * package.xml, CMakeLists.txt: add depends to diagnostic_updater
    * Contributors: Ryosuke Tajima, Tokyo Opensource Robotics Developer 534

 -- Tokyo Opensource Robotics Kyokai (TORK) Developer Team <dev@opensource-robotics.tokyo.jp>  Mon, 11 Sep 2017 15:00:00 -0000

ros-indigo-minas-control (1.0.4-0trusty) trusty; urgency=high

  * set license as GPLv2/CC-BY-SA,add LICENSE for meshes (#55 <https://github.com/tork-a/minas/issues/55>)
    * set license as GPLv2/CC-BY-SA,add LICENSE for meshes
    * cleanup code
    * fix wrong license data, add LICENSE information to xacro files
    * cleanup package.xml
  * Contributors: Ryosuke Tajima, Tokyo Opensource Robotics Developer 534

 -- Tokyo Opensource Robotics Kyokai (TORK) Developer Team <dev@opensource-robotics.tokyo.jp>  Sun, 10 Sep 2017 15:00:00 -0000

ros-indigo-minas-control (1.0.3-0trusty) trusty; urgency=high



 -- Tokyo Opensource Robotics Kyokai (TORK) Developer Team <dev@opensource-robotics.tokyo.jp>  Thu, 03 Aug 2017 15:00:00 -0000

ros-indigo-minas-control (1.0.2-0trusty) trusty; urgency=high

  * add more ROS_INFO message while insitializeing
  * use current readInputs and wait 10msec
  * servoon/servooff : printPDSstatus once every seconds
  * call reset before servooff in shutdown
  * Improve servo ON time
  * Contributors: Ryosuke Tajima, Tokyo Opensource Robotics Developer 534

 -- Tokyo Opensource Robotics Kyokai (TORK) Developer Team <dev@opensource-robotics.tokyo.jp>  Thu, 11 May 2017 15:00:00 -0000

ros-indigo-minas-control (1.0.1-0trusty) trusty; urgency=high

  * fix comments on params
  * On site fix 5/11 by Tajima
  * add comment
  * fix if condition
  * Contributors: Ryosuke Tajima, Tokyo Opensource Robotics Developer 534

 -- Tokyo Opensource Robotics Kyokai (TORK) Developer Team <dev@opensource-robotics.tokyo.jp>  Thu, 11 May 2017 15:00:00 -0000

ros-indigo-minas-control (1.0.0-0trusty) trusty; urgency=high

  * add test codes (`#39 <https://github.com/tork-a/minas/pull/39`_)
    * minas_control/src/main.cpp: continue running evern if mlockall failed, when we run with simulaiton
    * add depends to diagnostic_updator
  * use rosparam to set control param (`#33 <https://github.com/tork-a/minas/pull/33`_)
    * update install process, 1.0.0
    * doc/index.rst : use two-backquote instaad of backquote to show code block
    * doc/index.rst : comment on how to run tra1_bringup.launch and set controller parameters
    * use getParamFromROS function, read and display parameters in simulation mode too
    * move custom controller parameters for tra1 to tra1_bringup/launch/tra1_bringup.lauch
    * minas_control.launch add eth arg to set ether device name
  * Contributors: Tokyo Opensource Robotics Developer 534

 -- Tokyo Opensource Robotics Kyokai (TORK) Developer Team <dev@opensource-robotics.tokyo.jp>  Fri, 21 Apr 2017 15:00:00 -0000

ros-indigo-minas-control (0.5.2-0trusty) trusty; urgency=high

  * CMakeLists.txt: set INSTALL_RPARH_USE_LINK_PATH for preserving RPATH, fix #20 <https://github.com/tork-a/minas/issues/20>
  * CMakeLists.txt: do not remove debian/postinst on debbuild target
  * doc/index.rst: Fix some typos
  * doc/index.rst: add all deb files to install
  * Contributors: Tokyo Opensource Robotics Developer 7675, Tokyo Opensource Robotics Developer 534

 -- Tokyo Opensource Robotics Kyokai (TORK) Developer Team <dev@opensource-robotics.tokyo.jp>  Fri, 31 Mar 2017 15:00:00 -0000

ros-indigo-minas-control (0.5.1-0trusty) trusty; urgency=high

  * add debian/postinst to set cap/ipc
  * CMakeLists.txt add to install launch directory
  * Add error text for MinasClient::readInputs()
    - This is for #10 <https://github.com/tork-a/minas/issues/10>
  * fix typo on dpkg-i ros-indigo-*.deb section
  * Contributors: Tokyo Opensource Robotics Developer 7675, Tokyo Opensource Robotics Developer 534

 -- Tokyo Opensource Robotics Kyokai (TORK) Developer Team <dev@opensource-robotics.tokyo.jp>  Sat, 25 Mar 2017 15:00:00 -0000

ros-indigo-minas-control (0.5.0-0trusty) trusty; urgency=high



 -- Tokyo Opensource Robotics Kyokai (TORK) Developer Team <dev@opensource-robotics.tokyo.jp>  Sun, 05 Mar 2017 15:00:00 -0000

ros-indigo-minas-control (0.4.0-0trusty) trusty; urgency=high

  * add doc for step 4 (realtime control)


=== debian/control ===
Source: ros-indigo-minas-control
Section: misc
Priority: extra
Maintainer: Tokyo Opensource Robotics Kyokai (TORK) Developer Team <dev@opensource-robotics.tokyo.jp>
Build-Depends: debhelper (>= 9.0.0), libtinyxml-dev, ros-indigo-catkin, ros-indigo-controller-manager, ros-indigo-diagnostic-updater, ros-indigo-ethercat-manager, ros-indigo-hardware-interface, ros-indigo-joint-limits-interface, ros-indigo-roslaunch, ros-indigo-rostest, ros-indigo-sensor-msgs, ros-indigo-soem, ros-indigo-trajectory-msgs, ros-indigo-transmission-interface
Homepage: http://ros.org/wiki/minas_control
Standards-Version: 3.9.2

Package: ros-indigo-minas-control
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libtinyxml-dev, ros-indigo-controller-manager, ros-indigo-diagnostic-updater, ros-indigo-ethercat-manager, ros-indigo-hardware-interface, ros-indigo-joint-limits-interface, ros-indigo-sensor-msgs, ros-indigo-trajectory-msgs, ros-indigo-transmission-interface
Description: This package contains ros_control based robot controller for PANASONIC MINAS EtherCAT Motor Driver Control System

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/indigo/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/indigo" \
		-DCMAKE_PREFIX_PATH="/opt/ros/indigo"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-indigo-minas-control//opt/ros/indigo/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_install
